<template>
  <component
    :is="url ? 'nuxt-link' : 'button'"
    :to="url"
    class="button"
    :tabindex="0"
    :style="{
      width,
      height,
    }"
    :class="{
      [`button--state-${state}`]: !!state,
      [`button--size-${size}`]: !!size,
    }"
    @click="onClick"
  >
    <div class="button__container">
      <slot
        name="before"
        class="button__before"
      />
      <slot
        name="default"
        class="button__content"
      >
        {{ label }}
      </slot>
      <slot
        name="after"
        class="button__after"
      />
    </div>
  </component>
</template>

<script>
export default {
  name: 'Button',
  props: {
    url: {
      type: [String, Object],
      default: () => null,
    },
    label: {
      type: String,
      default: '',
    },
    height: {
      type: [Number, String],
      default: undefined,
    },
    width: {
      type: [Number, String],
      default: undefined,
    },
    state: {
      type: String,
      default: 'pure',
    },
    size: {
      type: String,
      default: undefined,
    },
  },
  methods: {
    onClick() {
      this.$emit('click');
    },
  },
};
</script>

<style lang="scss">
  @import "./button";
</style>
